/*
 * An opener for a "host" file provided via the C library.
 *
 * Copyright (C) 2021 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <map>

#include <fsserver/opener_resource.h>



/* Support for providing access to files. */

class HostFileOpener : public OpenerResource
{
protected:

    /* Configurable methods. */

    virtual fileid_t get_fileid(const char *path);

    virtual Accessor *make_accessor(const char *path, fileid_t fileid);

public:
    explicit HostFileOpener(Pages *pages)
    : OpenerResource(pages)
    {
    }
};

// vim: tabstop=4 expandtab shiftwidth=4
